import sys
import math

def eventually(data, size):
    result = []
    number_of_results = len(data) // size
    for i in range(0, len(data), size):
        for j in range(i + size, len(data) + 1, size):
            result.append(max(data[i:j]))
        if number_of_results * size < len(data):
            result.append(max(data[i:]))
    return result

def globally(data, size):
    result = []
    number_of_results = len(data) // size
    for i in range(0, len(data), size):
        for j in range(i + size, len(data) + 1, size):
            result.append(min(data[i:j]))
        if number_of_results * size < len(data):
            result.append(min(data[i:]))
    return result

def main(argv):

    with open(argv[1]) as signal_file:
        with open(argv[2], 'w') as arff_file:
            dimension = int(argv[3])
            window_size = int(argv[4])

            for i in range(dimension + 3):
                dummy = signal_file.readline()

            arff_file.write('@relation cpu\n')
            n = math.ceil(dimension / window_size)
            for i in range(n * (n + 1)):
                arff_file.write('@attribute {0} REAL\n'.format(i+1))
            arff_file.write('@attribute alarm {0, 1}\n')
            arff_file.write('@data\n')

            for line in signal_file:
                raw_data = line.split(',')
                label = int(raw_data[-1])
                data = [float(x) for x in raw_data[:-1]]
                data.reverse()

                result = globally(data, window_size)
                for elem in result:
                    arff_file.write('{0:.10f},'.format(elem))

                result = eventually(data, window_size)
                for elem in result:
                    arff_file.write('{0:.10f},'.format(elem))

                arff_file.write('{0}\n'.format(label))



if __name__ == "__main__":
    main(sys.argv)
