import sys
from collections import deque

def main(argv):
    signal_file_names = [argv[3]+str(n)+"_time_series" for n in range(int(argv[4]))]

    window_size = int(argv[2])
    with open(argv[1], 'w') as arff_file:
        arff_file.write('@relation cpu\n')
        for i in range(window_size):
            arff_file.write('@attribute {0} REAL\n'.format(i+1))
        arff_file.write('@attribute alarm {0, 1}\n')
        arff_file.write('@data\n')

        for i, sfn in enumerate(signal_file_names):
            with open(sfn) as signal_file:
                signals = deque(maxlen=window_size)
                labels = deque(maxlen=window_size)

                for signal_line in signal_file:
                    pair = signal_line.split()
                    signals.append(float(pair[0]))
                    labels.append(int(pair[1]))

                    if len(signals) == window_size:
                        for elem in signals:
                            arff_file.write('{0:.10f},'.format(elem))
                        arff_file.write('{0}\n'.format(int(pair[1])))


if __name__ == "__main__":
    main(sys.argv)
